local CO = require "api_coservice"
local MSG = require "api_msg"
local cjson = require "cjson"

local dset = {}
--------------------------------------
local function API_get( args)
	local proxy = CO.GetProxy( "/datetime", "systemctrl" )
	if not proxy then
		MSG.ERROR( "systemctrl Error" )
	else
		local r,zone,ofs = proxy.GetLocation()
		local ntp,ntp_servers
		r,ntp,ntp_servers = proxy.GetNtp()
		local addr,addrs_servers
		r,addr,addrs_servers = proxy.GetAddrs()
		proxy:Destroy()
		local timeStr = "pc"
		if ntp then
			timeStr = "ntp"
		elseif addr then
			timeStr = "addr"
		end
		MSG.OK("", {
			data = {
				time = os.date("%Y-%m-%d %H:%M:%S"),
				timetype = timeStr,
				-- timetype = ntp and "ntp" or ( addr and "addr" or "pc"),
				Timezone = zone or "Asia/Shanghai",
				ntp = ntp_servers,
				addrs = addrs_servers,
			}
		})
	end
	return true
end

--------------------------------------

local function API_modify( args)
	if args then
		local proxy = CO.GetProxy( "/datetime", "systemctrl" )
		if not proxy then
			MSG.ERROR( "systemctrl Error" )
		else
			local r,done
			if args.timezone then
				r, done = proxy.SetLocation(args.timezone, args.offset)
				if not r or not done then
					MSG.ERROR( "setTimezoneError" )
					proxy:Destroy()
				end
			end

			if args.timetype then
				if args.time then
					proxy.SetNtp(false)
					proxy.SetAddrs(false)
					proxy.SetDatetime( args.time )
				elseif args.ntp then
					proxy.SetAddrs(false)
					proxy.SetNtp( true, args.ntp )
				elseif args.addrs then
					proxy.SetNtp(false)
					proxy.SetAddrs(true, args.addrs)
				end
			end
			proxy:Destroy()
			MSG.OK()
		end
	else
		MSG.ERROR( "invalidArgError" )
	end
	return true
end

--------------------------------------

dset["get"] = API_get
dset["modify"] = API_modify

--------------------------------------
return dset
