if not ngx.var.hls_session then
	ngx.status = 404
	return
end

local CO = require "api_coservice"
local proxy = CO.GetProxy( "/streamer", "codec")
if not proxy then
	ngx.status = 500
	return
end

local function createResult(is_ok, ...)
	local data = {...}
	if not is_ok or not data[1] then
		return
	end
	--NOTE: 如果有多个返回值这里要处理一下
	if #data == 1 then
		data = data[1]
	end
	return data
end

local content = createResult(proxy.GetHLSM3U8( ngx.var.hls_session ))
proxy:Destroy()
if not content then
	ngx.status = 404
	return
end

for r=1, #content do
	if content[r] == "" or content[r]:sub(1,1) == "#" then
		ngx.print( content[r] )
		ngx.print( "\r\n" )
	else --File, so need add prefix.
		--ngx.print( "/hls/" .. ngx.var.hls_session .. "/" .. content[r] )
		ngx.print( content[r] )
		ngx.print( "\r\n" )
	end
end

