#!/usr/bin/env lua
if type(arg) ~= "table" or #arg < 2 then
	os.exit(1)
end

local client = require "coaf.client"
local adapter = require "coaf.cli_adapter.simple"
client.InitSocket(nil, adapter)

local function GetProxy(objPath, service, loc, timeout, socket_addr)
	local proxy
	local cli

	cli = client.New( service, loc, socket_addr, timeout or 5 ) --5 seconds timeout.
	if not cli then
		_dbg.Error( "CO", "Fail to create connection to service '" .. (loc or "local") .. "/" .. (service or "nil") )
		return nil
	end
	proxy = cli:CreateProxy(objPath, true) --Exclusive
	if not proxy then
		_dbg.Error( "CO", "Fail to create object proxy for '" .. (objPath or "unknown") .. "'" )
		return nil
	end
	return proxy
end

while true do
	local proxy = GetProxy("/record", "record")
	if proxy then
		proxy.DiskAttach( arg[1], arg[2], arg[3] or "", arg[4] )
		proxy:Destroy()
		return
	end
end
