local DC = require "supertable.declare"
local CONF = require "supertable.core"
local capture
local pt = require "pl.pretty"

local function onVideoSourceChanged(cfg)
    -- TODO: 后续还需要有NDI源的切换
end

local _M = {
	config_file = "/data/configs/capture_config.conf"
}

local capture_template = DC.ARR(
    DC.OBJ{
        brightness = DC.INT(128),
        contrast = DC.INT(128),
        saturation = DC.INT(128),
        videoSource = DC.STR("hdmi") : __changed(onVideoSourceChanged),
        mode = DC.STR("BT1120"),
        rotate = DC.INT(0),
        sourceFrameRate = DC.NUM(60),
        stCapRect = DC.ARR(
            DC.INT(0),
            DC.INT(0),
            DC.INT(1920),
            DC.INT(1080)
        ),
        stDestSize = DC.ARR(
            DC.INT(1920),
            DC.INT(1080)
        ),
        enCapSel = DC.STR("BOTH"),
        enScanMode = DC.STR("PROGRESSIVE"),
        enPixFormat = DC.STR("YUV_SEMIPLANAR_420"),
        bMirror = DC.BOOL(false),
        bFlip = DC.BOOL(false),
        s32SrcFrameRate = DC.INT(-1), --NOTE:不进行帧率控制
        s32DstFrameRate = DC.INT(-1)
    }
) : __changed( function(conf)
    conf:TAB_SAVE()
end)

local default = {
    {
        brightness = 128,
        contrast = 128,
        saturation = 128,
        videoSource = "hdmi",
        mode = "BT1120",
        rotate = 0,
        stCapRect = {0, 0, 3840, 2160},
        stDestSize = {3840, 2160},
        enCapSel = "BOTH",
        enScanMode = "PROGRESSIVE", --逐行
        --enScanMode = "INTERLACED", --隔行
        enPixFormat = "YUV_SEMIPLANAR_420",
        bMirror = false,
        bFlip = false,
        sourceFrameRate = 60,
        s32SrcFrameRate = -1, --不进行帧率控制
        s32DstFrameRate = -1
    },
}

--------------------------------------------
function _M.Load()
	local conf = CONF.Create({}, capture_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	local _, r = conf:TAB_LOAD()
	if not r then --Try load a fail-default configure
		conf:TAB_BIND( default )
	end

	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------
return _M