local DC = require "supertable.declare"
local CONF = require "supertable.core"
local mod_OSD

local _M = {
	config_file = "/data/configs/medusers.conf"
}

--------------------------------------------------------
local mediaUsers_template = DC.ARR(
    DC.OBJ{
        username = DC.STR(""),
        password = DC.STR("")
    }
) : __changed( function(conf)
	conf:TAB_SAVE()
end)

-------------------------------------------------------
local default = {
	{
		username = "admin",
		password = "admin"
	}
}
-------------------------------------------------------
function _M.Load()
	local conf = CONF.Create({}, mediaUsers_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	local _, r = conf:TAB_LOAD()
	if not r then --Try load a fail-default configure
		conf:TAB_BIND( default )
	end

	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------

return _M


