local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/vpss.conf"
}

--------------------------------------------------------

local vpss_template = DC.OBJ{
    enable = DC.BOOL(false),
    s32X = DC.NUM(25),
    s32Y = DC.NUM(25),
    u32Height = DC.NUM(50),
    u32Width = DC.NUM(50)
} : __changed( function(conf)
	conf:TAB_SAVE()
end)

local default = {
    enable = false,
    s32X = 25,
    s32Y = 25,
    u32Height = 50,
    u32Width = 50,
}

-------------------------------------------------------
function _M.Load()
	local conf = CONF.Create({}, vpss_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	local _, r = conf:TAB_LOAD()
    if not r then
		conf:TAB_BIND( default )
    end
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------

return _M


