------------------------------------------------------
-- AIBAO overlay application global initialzation.
------------------------------------------------------
require "himpp"

local SYS = HiMPP.SYS
local VB = HiMPP.VB

local _M = {}

-- Cleanup the MPP system.
function _M.Cleanup()
	SYS.Exit()
	local i
	for i=0, VB.MAX_USER-1 do
		VB.ExitModCommPool(i)
	end

	for i=0, VB.MAX_POOLS-1 do
		VB.DestroyPool(i)
	end

	VB.Exit()
end

-- Init the MPP system.
function _M.Init()
	print("*********************** SYS exit:", string.format("%08X",
	SYS.Exit()
	))
	print("*********************** VB exit:", string.format("%08X",
	VB.Exit()
	))

	--First, setup the VB.
	print("*********************** VB config:", string.format("%08X",
	VB.Config( 128, --Max pool count (?128)
		{
			-- { u32BlkSize = 3840*2160*2, u32BlkCnt = 10, acMmzName = "kiloview"},
			{ u32BlkSize = 3840*2176*2, u32BlkCnt = 20},
		}
	)
	))

	VB.Init()
	SYS.Init()
end

return _M


