local DC = require "supertable.declare"
local CONF = require "supertable.core"
local function OnControlChanged(obj)
	local onvif_mod = require "onvifModule"
	onvif_mod.Reconfig()
end

local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/onvif.conf"
}

local onvif_template = DC.OBJ{
	control = DC.OBJ{
		enabled = DC.INT(1),
		port = DC.INT(8080),
		discoverPort = DC.INT(3702),
	} : __changed(OnControlChanged),
	discoverable = DC.INT(1),
	location = DC.STR("default"),
	timezone = DC.STR("GMT-8"),
	deviceType = DC.STR(""),
	deviceName = DC.STR(""),
	auth_req = DC.INT(0),
	adminName = DC.STR("Administrator"),
	adminPassword = DC.STR("admin"),
	users = DC.ARR(
		DC.OBJ{
			username = DC.STR(""),
			password = DC.STR(""),
			name = DC.STR(""),
			role = DC.STR("user"),
		}
	)
} : __changed( function(conf)
	conf:TAB_SAVE()
end)

local default = {
	control = {
		enabled = 1,
		port = 8080,
		discoverPort = 3702,
	},
	discoverable = 1,
	location = "default",
	timezone = "GMT-8",
	deviceType = "",
	deviceName = "",
	auth_req = 0,
	adminName = "Administrator",
	adminPassword = "admin",
	users = {}
}

-------------------------------------------------------
function _M.Load()
	local conf = CONF.Create({}, onvif_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	local _, r = conf:TAB_LOAD()
    if not r then
		conf:TAB_BIND( default )
    end
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------

return _M


